diff --git a/gcc/diagnostic-show-locus.c b/gcc/diagnostic-show-locus.c
index 147a2b8..60013e8 100644
--- a/gcc/diagnostic-show-locus.c
+++ b/gcc/diagnostic-show-locus.c
@@ -27,6 +27,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "backtrace.h"
 #include "diagnostic.h"
 #include "diagnostic-color.h"
+#include "box-drawing.h"
 
 #ifdef HAVE_TERMIOS_H
 # include <termios.h>
@@ -60,6 +61,805 @@ adjust_line (const char *line, int line_width,
   return line;
 }
 
+/* Is (column, row) within the given range?
+
+   Ranges are closed (both limits are within the range).
+
+   Example A: a single-line range:
+     start:  (col=22, line=2)
+     finish: (col=38, line=2)
+
+  |00000011111111112222222222333333333344444444444
+  |34567890123456789012345678901234567890123456789
+--+-----------------------------------------------
+01|bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
+02|bbbbbbbbbbbbbbbbbbbSwwwwwwwwwwwwwwwFaaaaaaaaaaa
+03|aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
+
+   Example B: a multiline range with
+     start:  (col=14, line=3)
+     finish: (col=08, line=5)
+
+  |00000011111111112222222222333333333344444444444
+  |34567890123456789012345678901234567890123456789
+--+-----------------------------------------------
+01|bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
+02|bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
+03|bbbbbbbbbbbSwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
+04|wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
+05|wwwwwFaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
+06|aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
+--+-----------------------------------------------
+
+   Legend:
+   - 'b' indicates a point *before* the range
+   - 'S' indicates the start of the range
+   - 'w' indicates a point within the range
+   - 'F' indicates the finish of the range (which is
+	 within it).
+   - 'a' indicates a subsequent point *after* the range.  */
+
+bool
+location_range::contains_point (int row, int column) const
+{
+  gcc_assert (m_start.line <= m_finish.line);
+  /* ...but the equivalent isn't true for the columns;
+     consider example B in the comment above.  */
+
+  if (row < m_start.line)
+    /* Points before the first line of the range are
+       outside it (corresponding to line 01 in example A
+       and lines 01 and 02 in example B above).  */
+    return false;
+
+  if (row == m_start.line)
+    /* On same line as start of range (corresponding
+       to line 02 in example A and line 03 in example B).  */
+    {
+      if (column < m_start.column)
+	/* Points on the starting line of the range, but
+	   before the column in which it begins.  */
+	return false;
+
+      if (row < m_finish.line)
+	/* This is a multiline range; the point
+	   is within it (corresponds to line 03 in example B
+	   from column 14 onwards) */
+	return true;
+      else
+	{
+	  /* This is a single-line range.  */
+	  gcc_assert (row == m_finish.line);
+	  return column <= m_finish.column;
+	}
+    }
+
+  /* The point is in a line beyond that containing the
+     start of the range: lines 03 onwards in example A,
+     and lines 04 onwards in example B.  */
+  gcc_assert (row > m_start.line);
+
+  if (row > m_finish.line)
+    /* The point is beyond the final line of the range
+       (lines 03 onwards in example A, and lines 06 onwards
+       in example B).  */
+    return false;
+
+  if (row < m_finish.line)
+    {
+      /* The point is in a line that's fully within a multiline
+	 range (e.g. line 04 in example B).  */
+      gcc_assert (m_start.line < m_finish.line);
+      return true;
+    }
+
+  gcc_assert (row ==  m_finish.line);
+
+  return column <= m_finish.column;
+}
+
+/* Return true if (ROW/COLUMN) is within a range of RICHLOC.
+   If it returns true, OUT_RANGE_IDX and OUT_DRAW_CARET_P are
+   written to, with the range index, and whether we should draw
+   the caret at (ROW/COLUMN) (as opposed to an underline).  */
+
+static bool
+get_state_at_point (/* Inputs.  */
+		    int row, int column, rich_location *richloc,
+		    int first_non_ws, int last_non_ws,
+		    /* Outputs.  */
+		    int *out_range_idx,
+		    bool *out_draw_caret_p)
+{
+  /* Within a multiline range, don't display any underline or caret
+     in any leading or trailing whitespace on a line.  */
+  if (column < first_non_ws || column > last_non_ws)
+    return false;
+
+  for (rich_location::range_iter iter = richloc->iter_ranges ();
+       !iter.at_end ();
+       iter.next())
+    {
+      const location_range *range = *iter;
+
+      if (0)
+	fprintf (stderr,
+		 "range ( (%i, %i), (%i, %i))->contains_point (%i, %i): %s\n",
+		 range->m_start.line,
+		 range->m_start.column,
+		 range->m_finish.line,
+		 range->m_finish.column,
+		 row,
+		 column,
+		 range->contains_point (row, column) ? "true" : "false");
+
+      if (range->contains_point (row, column))
+	{
+	  *out_range_idx = iter.index();
+
+	  /* Are we at the range's caret?  is it visible? */
+	  *out_draw_caret_p = false;
+	  if (row == range->m_start.line
+	      && column == range->m_start.column)
+	    *out_draw_caret_p = range->m_show_caret_p;
+
+	  /* We are within a range.  */
+	  return true;
+	}
+    }
+
+  return false;
+}
+
+/* Get the column beyond the rightmost one that could contain a caret or
+   range marker, given that we stop rendering at trailing whitespace.  */
+
+static int
+get_x_bound_for_row (int row, int caret_column,
+		     rich_location *richloc,
+		     int last_non_ws)
+{
+  int result = caret_column + 1;
+
+  for (rich_location::range_iter iter = richloc->iter_ranges ();
+       !iter.at_end ();
+       iter.next())
+    {
+      const location_range *range = *iter;
+      if (row >= range->m_start.line)
+	{
+	  if (range->m_finish.line == row)
+	    {
+	      /* On the final line within a range; ensure that
+		 we render up to the end of the range.  */
+	      if (result <= range->m_finish.column)
+		result = range->m_finish.column + 1;
+	    }
+	  else if (row < range->m_finish.line)
+	    {
+	      /* Within a multiline range; ensure that we render up to the
+		 last non-whitespace column.  */
+	      if (result <= last_non_ws)
+		result = last_non_ws + 1;
+	    }
+	}
+    }
+
+  return result;
+}
+
+/* Classes for rendering source code and diagnostics, within an
+   anonymous namespace.
+   The work is done by "class layout", which embeds and uses
+   "class colorizer" and "class per_range_info" to get things done.  */
+
+namespace {
+
+/* A class to inject colorization codes when printing the diagnostic locus,
+   tracking state as it goes.  */
+
+class colorizer
+{
+ public:
+  colorizer (diagnostic_context *context,
+	     const diagnostic_info *diagnostic);
+  ~colorizer ();
+
+  void set_range (int range_idx) { set_state (range_idx); }
+  void set_normal_text () { set_state (STATE_NORMAL_TEXT); }
+
+ private:
+  void set_state (int state);
+  void begin_state (int state);
+  void finish_state (int state);
+
+ private:
+  static const int STATE_NORMAL_TEXT = -1;
+
+  diagnostic_context *m_context;
+  const diagnostic_info *m_diagnostic;
+  int m_current_state;
+  const char *m_caret_cs;
+  const char *m_caret_ce;
+  const char *m_range1_cs;
+  const char *m_range2_cs;
+  const char *m_range_ce;
+};
+
+/* A class for use by "class layout" below for capturing information on
+   how to display a specific range within a rich_location.  */
+
+class per_range_info
+{
+ public:
+  per_range_info (int range_idx);
+
+  int get_range_index () const { return m_range_idx; }
+
+  void add_uniquely_captioned_row (int row);
+
+  int get_first_unique_row () const;
+  int get_last_unique_row () const;
+
+  bool contains_line (int line) const;
+
+  void determine_location_for_caption (const char *filename);
+
+  int get_caption_row () const { return m_caption_row; }
+  int get_caption_column () const { return m_caption_column; }
+
+ private:
+  int m_range_idx;
+  auto_vec<int> m_unique_rows;
+  int m_caption_row;
+  int m_caption_column;
+};
+
+/* A class to control the overall layout of a diagnostic.
+
+   The layout is determined within the constructor.
+   It is then printed by repeatedly calling the "print_line" method.
+   Each such call can print two lines: one for the source line itself,
+   and potentially an "annotation" line, containing carets/underlines.
+   Both such lines could be printed with a right-hand margin, containing
+   additional information.
+
+   For now, we just support the case of a single margin at once,
+   showing any captioned ranges that exclusively occupy their lines.
+
+   We also assume we have disjoint ranges.  */
+
+class layout
+{
+ public:
+  layout (diagnostic_context *context,
+	  const diagnostic_info *diagnostic);
+
+  void print_line (int row);
+
+ private:
+  enum print_line_kind {
+    PRINT_LINE_KIND_SOURCE,
+    PRINT_LINE_KIND_ANNOTATION};
+
+ private:
+  per_range_info *
+  get_any_range (int line);
+
+  void
+  print_any_margin (int line, int column, enum print_line_kind kind);
+
+ private:
+  diagnostic_context *m_context;
+  pretty_printer *m_pp;
+  diagnostic_t m_diagnostic_kind;
+  rich_location *m_richloc;
+  expanded_location m_exploc;
+  colorizer m_colorizer;
+  auto_vec <per_range_info> m_per_range_vec;
+};
+
+/* Implementation of "class colorizer".  */
+
+/* The constructor for "colorizer".  Lookup and store color codes for the
+   different kinds of things we might need to print.  */
+
+colorizer::colorizer (diagnostic_context *context,
+		      const diagnostic_info *diagnostic) :
+  m_context (context),
+  m_diagnostic (diagnostic),
+  m_current_state (STATE_NORMAL_TEXT)
+{
+  m_caret_ce = colorize_stop (pp_show_color (context->printer));
+  m_range1_cs = colorize_start (pp_show_color (context->printer), "range1");
+  m_range2_cs = colorize_start (pp_show_color (context->printer), "range2");
+  m_range_ce = colorize_stop (pp_show_color (context->printer));
+}
+
+/* The destructor for "colorize".  If colorization is on, print a code to
+   turn it off.  */
+
+colorizer::~colorizer ()
+{
+  finish_state (m_current_state);
+}
+
+/* Update state, printing color codes if necessary if there's a state
+   change.  */
+
+void
+colorizer::set_state (int new_state)
+{
+  if (m_current_state != new_state)
+    {
+      finish_state (m_current_state);
+      m_current_state = new_state;
+      begin_state (new_state);
+    }
+}
+
+/* Turn on any colorization for STATE.  */
+
+void
+colorizer::begin_state (int state)
+{
+  switch (state)
+    {
+    case STATE_NORMAL_TEXT:
+      break;
+
+    case 0:
+      /* Make range 0 be the same color as the "kind" text
+	 (error vs warning vs note).  */
+      pp_string
+	(m_context->printer,
+	 colorize_start (pp_show_color (m_context->printer),
+			 diagnostic_get_color_for_kind (m_diagnostic->kind)));
+      break;
+
+    case 1:
+      pp_string (m_context->printer, m_range1_cs);
+      break;
+
+    case 2:
+      pp_string (m_context->printer, m_range2_cs);
+      break;
+
+    default:
+      /* We don't expect more than 3 ranges per diagnostic.  */
+      gcc_unreachable ();
+      break;
+    }
+}
+
+/* Turn off any colorization for STATE.  */
+
+void
+colorizer::finish_state (int state)
+{
+  switch (state)
+    {
+    case STATE_NORMAL_TEXT:
+      break;
+
+    case 0:
+      pp_string (m_context->printer, m_caret_ce);
+      break;
+
+    default:
+      /* Within a range.  */
+      gcc_assert (state > 0);
+      pp_string (m_context->printer, m_range_ce);
+      break;
+    }
+}
+
+/* Implementation of class per_range_info.  */
+
+/* The constructor for class per_range_info.  */
+
+per_range_info::per_range_info (int range_idx)
+: m_range_idx (range_idx),
+  m_unique_rows ()
+{
+}
+
+/* FIXME.  */
+
+void
+per_range_info::add_uniquely_captioned_row (int row)
+{
+  m_unique_rows.safe_push (row);
+}
+
+/* FIXME.  */
+
+int
+per_range_info::get_first_unique_row () const
+{
+  gcc_assert (m_unique_rows.length () > 0);
+  return m_unique_rows[0];
+}
+
+/* FIXME.  */
+
+int
+per_range_info::get_last_unique_row () const
+{
+  gcc_assert (m_unique_rows.length () > 0);
+
+  return m_unique_rows[m_unique_rows.length () - 1];
+}
+
+/* FIXME.  */
+
+bool
+per_range_info::contains_line (int line) const
+{
+  if (0 == m_unique_rows.length ())
+    return false;
+
+  return (line >= get_first_unique_row ()
+	  && line <= get_last_unique_row ());
+}
+
+/* FIXME.  */
+
+static int
+get_line_width_without_trailing_whitespace (const char *line, int line_width)
+{
+  int result = line_width;
+  while (result > 0)
+    {
+      char ch = line[result - 1];
+      if (ch == ' ' || ch == '\t')
+	result--;
+      else
+	break;
+    }
+  gcc_assert (result >= 0);
+  gcc_assert (result <= line_width);
+  gcc_assert (result == 0 ||
+	      (line[result - 1] != ' '
+	       && line[result -1] != '\t'));
+  return result;
+}
+
+/* FIXME.  */
+
+void
+per_range_info::determine_location_for_caption (const char *filename)
+{
+  if (0 == m_unique_rows.length ())
+    return;
+
+  /* Determine the widest line, using it as the column in which to render
+     the caption (m_caption_column).  */
+  int result = 0;
+  for (int row = get_first_unique_row ();
+       row <= get_last_unique_row ();
+       row++)
+    {
+      int line_width;
+      const char *line = location_get_source_line (filename, row, &line_width);
+      line_width = get_line_width_without_trailing_whitespace (line,
+							       line_width);
+      if (result < line_width)
+	result = line_width + 1;
+    }
+  m_caption_column = result;
+
+  /* Determine which row to write the caption text in: the middle row
+     within the range, rounding down mathematically (and thus up
+     visually).  */
+  m_caption_row = (get_first_unique_row () + get_last_unique_row ()) / 2;
+}
+
+/* Implementation of class layout.  */
+
+/* Constructor for class layout.
+   FIXME.  */
+
+layout::layout (diagnostic_context * context,
+		const diagnostic_info *diagnostic)
+: m_context (context),
+  m_pp (context->printer),
+  m_diagnostic_kind (diagnostic->kind),
+  m_richloc (diagnostic->richloc),
+  m_exploc (m_richloc->lazily_expand_location ()),
+  m_colorizer (context, diagnostic),
+  m_per_range_vec ()
+{
+  for (rich_location::range_iter iter = m_richloc->iter_ranges ();
+       !iter.at_end ();
+       iter.next())
+    {
+      per_range_info ri (iter.index ());
+      m_per_range_vec.safe_push (ri);
+    }
+
+  /* For each row, determine if it has a unique captioned range.  */
+  int last_line = m_richloc->get_last_line ();
+  for (int row = m_richloc->get_first_line ();
+       row <= last_line;
+       row++)
+    {
+      int num_captions_in_row = 0;
+      const location_range *first_caption = NULL;
+      int first_caption_idx = 0; /* silence "maybe-uninitialized" warning
+				    (PR 67196).  */
+      for (rich_location::range_iter iter = m_richloc->iter_ranges ();
+	   !iter.at_end ();
+	   iter.next())
+	{
+	  const location_range *range = *iter;
+	  if (range->m_caption)
+	    {
+	      if (row >= range->m_start.line
+		  && row <= range->m_finish.line)
+		{
+		  num_captions_in_row++;
+		  if (!first_caption)
+		    {
+		      first_caption = range;
+		      first_caption_idx = iter.index ();
+		    }
+		}
+	    }
+	}
+      if (first_caption && num_captions_in_row == 1)
+	m_per_range_vec[first_caption_idx].add_uniquely_captioned_row (row);
+    }
+
+  /* At this stage, each per_range_info now has a list of lines for which its
+     location_range uniquely captions that source line.  */
+
+  /* Next, calculate the best position in which to draw each caption.  */
+  per_range_info *ri;
+  int i;
+  FOR_EACH_VEC_ELT (m_per_range_vec, i, ri)
+    ri->determine_location_for_caption (m_richloc->get_range (i)->m_start.file);
+}
+
+/* Print text describing a line of source code.
+   This typically prints two lines:
+
+   (1) the source code itself, colorized at any ranges, and
+   (2) an annotation line containing any carets/underlines
+   describing the ranges.
+
+   Both lines (1) and (2) may contain a right-most margin containing a
+   vertical bar and a caption, describing a range.  */
+
+void
+layout::print_line (int row)
+{
+  int line_width;
+  const char *line = location_get_source_line (m_exploc.file, row,
+					       &line_width);
+  if (!line)
+    return;
+
+  m_colorizer.set_normal_text ();
+
+  /* Step 1: print the source code line.  */
+
+  /* We will stop printing at any trailing whitespace.  */
+  line_width
+    = get_line_width_without_trailing_whitespace (line,
+						  line_width);
+  pp_space (m_pp);
+  int first_non_ws = INT_MAX;
+  int last_non_ws = 0;
+  int column;
+  for (column = 1; column <= line_width; column++)
+    {
+      bool in_range_p;
+      int range_idx;
+      bool draw_caret_p;
+      in_range_p = get_state_at_point (row, column,
+				       m_richloc,
+				       0, INT_MAX,
+				       &range_idx, &draw_caret_p);
+      if (in_range_p)
+	m_colorizer.set_range (range_idx);
+      else
+	m_colorizer.set_normal_text ();
+      char c = *line == '\t' ? ' ' : *line;
+      if (c == '\0')
+	c = ' ';
+      if (c != ' ')
+	{
+	  last_non_ws = column;
+	  if (first_non_ws == INT_MAX)
+	    first_non_ws = column;
+	}
+      pp_character (m_pp, c);
+      line++;
+    }
+  print_any_margin (row, column, PRINT_LINE_KIND_SOURCE);
+
+  pp_newline (m_pp);
+
+  /* Step 2: print a line consisting of the caret/underlines for the
+     given source line.  */
+  int x_bound = get_x_bound_for_row (row, m_exploc.column,
+				     m_richloc,
+				     last_non_ws);
+
+  pp_space (m_pp);
+  for (int column = 1; column < x_bound; column++)
+    {
+      bool in_range_p;
+      int range_idx;
+      bool draw_caret_p;
+      in_range_p = get_state_at_point (row, column,
+				       m_richloc,
+				       first_non_ws, last_non_ws,
+				       &range_idx, &draw_caret_p);
+      if (in_range_p)
+	{
+	  /* Within a range.  Draw either the caret or an underline.  */
+	  m_colorizer.set_range (range_idx);
+	  if (draw_caret_p)
+	    /* Draw the caret.  */
+	    pp_string (m_pp, m_context->caret_chars[range_idx]);
+	  else
+	    {
+	      /* Within a range, but not drawing the caret.  Draw an underline
+		 character. */
+	      const location_range *range
+		= m_richloc->get_range (range_idx);
+	      if (range->m_start.line != range->m_finish.line)
+		{
+		  /* Underline multiline ranges using southwest/southeast
+		     corners for the very first/last positions, and hbar
+		     everywhere else.  */
+		  if (row == range->m_start.line
+		      && column == range->m_start.column)
+		    /* Start of multiline range: use a southwest corner for
+		       the underline.  */
+		    pp_string (m_pp, g_line_art.underline_start);
+		  else if (row == range->m_finish.line
+			   && column == range->m_finish.column)
+		    /* End of multiline range: use a southeast corner for
+		       the underline.  */
+		    pp_string (m_pp, g_line_art.underline_end);
+		  else
+		    pp_string (m_pp, g_line_art.underline_hbar);
+		}
+	      else
+		/* Render single-line ranges with the hbar character
+		   throughout.  */
+		pp_string (m_pp, g_line_art.underline_hbar);
+	    }
+	}
+      else
+	{
+	  /* Not in a range.  */
+	  m_colorizer.set_normal_text ();
+	  pp_character (m_pp, ' ');
+	}
+    }
+  print_any_margin (row, x_bound, PRINT_LINE_KIND_ANNOTATION);
+  pp_newline (m_pp);
+}
+
+/* Given a line of source code, get the per_range_info for the first range
+   within it, or NULL if there are no ranges.  */
+
+per_range_info *
+layout::get_any_range (int line)
+{
+  int i;
+  per_range_info *ri;
+  FOR_EACH_VEC_ELT (m_per_range_vec, i, ri)
+    if (ri->contains_line (line))
+      return ri;
+  return NULL;
+}
+
+/* Helper function for layout::print_line, to print the right-most margin
+   area (for both kinds of line, source and caret/underline).  */
+
+void
+layout::print_any_margin (int line, int column, enum print_line_kind kind)
+{
+  /* Locate the range layout for this line, if any.  */
+  per_range_info *ri = get_any_range (line);
+
+  /* If we're not in a range, there's no margin.  */
+  if (!ri)
+    return;
+
+  /* Fill with whitespace to get to the appropriate y-coordinate for
+     the margin.  */
+  while (column++ < ri->get_caption_column ())
+    pp_space (m_pp);
+
+  /* Colorize based on the range.  */
+  int range_idx = ri->get_range_index ();
+  m_colorizer.set_range (range_idx);
+
+  /* Draw a vertical line, with corners pointing to the left,
+     (falling back to '|' if unicode box-drawing is not available),
+     printing any caption on the *annotation* line for the
+     appropriate source line*/
+
+  if (line == ri->get_caption_row ()
+      && kind == PRINT_LINE_KIND_ANNOTATION)
+    {
+      /* We are on the annotation line of the
+	 appropriate source line to print the caption.  */
+
+      /* Draw the line before the caption.  */
+      pp_string (m_pp,
+		 line == ri->get_last_unique_row ()
+		 ? g_line_art.rmargin_caption_row_at_end
+		 : g_line_art.rmargin_caption_row);
+
+      location_range *range
+	= m_richloc->get_range (ri->get_range_index ());
+      gcc_assert (range);
+
+     /* Display any caption.  */
+      if (range->m_caption)
+	pp_string (m_pp, range->m_caption);
+    }
+  else if (line == ri->get_first_unique_row ()
+	   && kind == PRINT_LINE_KIND_SOURCE)
+    /* Start of multiline range.  */
+    pp_string (m_pp, g_line_art.rmargin_start);
+  else if (line == ri->get_last_unique_row ()
+	   && kind == PRINT_LINE_KIND_ANNOTATION)
+    /* End of multiline range.  */
+    pp_string (m_pp, g_line_art.rmargin_end);
+  else
+    /* A normal row: a vertical line.  */
+    pp_string (m_pp, g_line_art.rmargin_vbar);
+}
+
+} /* End of anonymous namespace.  */
+
+/* For debugging layout issues in diagnostic_show_locus and friends,
+   render a ruler giving column numbers (after the 1-column indent).  */
+
+static void
+show_ruler (diagnostic_context *context, int max_width)
+{
+  /* Hundreds.  */
+  if (max_width > 99)
+    {
+      pp_space (context->printer);
+      for (int column = 1; column < max_width; column++)
+	if (0 == column % 10)
+	  pp_character (context->printer, '0' + (column / 100) % 10);
+	else
+	  pp_space (context->printer);
+      pp_newline (context->printer);
+    }
+
+  /* Tens.  */
+  pp_space (context->printer);
+  for (int column = 1; column < max_width; column++)
+    if (0 == column % 10)
+      pp_character (context->printer, '0' + (column / 10) % 10);
+    else
+      pp_space (context->printer);
+  pp_newline (context->printer);
+
+  /* Units.  */
+  pp_space (context->printer);
+  for (int column = 1; column < max_width; column++)
+    pp_character (context->printer, '0' + (column % 10));
+  pp_newline (context->printer);
+}
+
+/* FIXME.  */
+extern void
+diagnostic_print_ranges (diagnostic_context * context,
+			 const diagnostic_info *diagnostic);
+
 /* Print the physical source line corresponding to the location of
    this diagnostic, and a caret indicating the precise column.  This
    function only prints two caret characters if the two locations
@@ -75,16 +875,25 @@ diagnostic_show_locus (diagnostic_context * context,
     return;
 
   context->last_location = diagnostic_location (diagnostic, 0);
-  expanded_location s0 = diagnostic_expand_location (diagnostic, 0);
-  expanded_location s1 = { };
-  /* Zero-initialized. This is checked later by diagnostic_print_caret_line.  */
 
-  if (diagnostic_location (diagnostic, 1) > BUILTINS_LOCATION)
-    s1 = diagnostic_expand_location (diagnostic, 1);
+  if (0)
+    {
+      /* The GCC 5 routine. */
+      expanded_location s0 = diagnostic_expand_location (diagnostic, 0);
+      expanded_location s1 = { };
+      /* Zero-initialized. This is checked later by
+	 diagnostic_print_caret_line.  */
 
-  diagnostic_print_caret_line (context, s0, s1,
-			       context->caret_chars[0],
-			       context->caret_chars[1]);
+      if (diagnostic_num_locations (diagnostic) >= 2)
+	s1 = diagnostic->message.m_richloc->get_range (1)->m_start;
+
+      diagnostic_print_caret_line (context, s0, s1,
+				   context->caret_chars[0],
+				   context->caret_chars[1]);
+    }
+  else
+    /* The GCC 6 routine.  */
+    diagnostic_print_ranges (context, diagnostic);
 }
 
 /* Print (part) of the source line given by xloc1 with caret1 pointing
@@ -96,7 +905,7 @@ void
 diagnostic_print_caret_line (diagnostic_context * context,
 			     expanded_location xloc1,
 			     expanded_location xloc2,
-			     char caret1, char caret2)
+			     const char *caret1, const char *caret2)
 {
   if (!diagnostic_same_line (context, xloc1, xloc2))
     /* This will mean ignore xloc2.  */
@@ -126,6 +935,8 @@ diagnostic_print_caret_line (diagnostic_context * context,
   pp_newline (context->printer);
   const char *saved_prefix = pp_get_prefix (context->printer);
   pp_set_prefix (context->printer, NULL);
+  /* FIXME: need to reimplement the adjust_line margin-adjustment logic
+     for the case of multiline, with ranges as well as carets.  */
   pp_space (context->printer);
   while (max_width > 0 && line_width > 0)
     {
@@ -145,22 +956,50 @@ diagnostic_print_caret_line (diagnostic_context * context,
   caret_ce = colorize_stop (pp_show_color (context->printer));
   int cmin = xloc2.column
     ? MIN (xloc1.column, xloc2.column) : xloc1.column;
-  int caret_min = cmin == xloc1.column ? caret1 : caret2;
-  int caret_max = cmin == xloc1.column ? caret2 : caret1;
+  const char *caret_min = cmin == xloc1.column ? caret1 : caret2;
+  const char *caret_max = cmin == xloc1.column ? caret2 : caret1;
 
   /* cmin is >= 1, but we indent with an extra space at the start like
      we did above.  */
   int i;
   for (i = 0; i < cmin; i++)
     pp_space (context->printer);
-  pp_printf (context->printer, "%s%c%s", caret_cs, caret_min, caret_ce);
+  pp_printf (context->printer, "%s%s%s", caret_cs, caret_min, caret_ce);
 
   if (xloc2.column)
     {
       for (i++; i < cmax; i++)
 	pp_space (context->printer);
-      pp_printf (context->printer, "%s%c%s", caret_cs, caret_max, caret_ce);
+      pp_printf (context->printer, "%s%s%s", caret_cs, caret_max, caret_ce);
     }
   pp_set_prefix (context->printer, saved_prefix);
   pp_needs_newline (context->printer) = true;
 }
+
+/* FIXME.  */
+
+void
+diagnostic_print_ranges (diagnostic_context * context,
+			 const diagnostic_info *diagnostic)
+{
+  int max_width = context->caret_max_width;
+
+  pp_newline (context->printer);
+
+  const char *saved_prefix = pp_get_prefix (context->printer);
+  pp_set_prefix (context->printer, NULL);
+
+  if (0)
+    show_ruler (context, max_width);
+
+  {
+    layout layout (context, diagnostic);
+    int last_line = diagnostic->richloc->get_last_line ();
+    for (int row = diagnostic->richloc->get_first_line ();
+	 row <= last_line;
+	 row++)
+      layout.print_line (row);
+  }
+
+  pp_set_prefix (context->printer, saved_prefix);
+}
